package nl.ivojonker.p8export.filenet;

import javax.security.auth.Subject;

import com.filenet.api.collection.RepositoryRowSet;
import com.filenet.api.core.Domain;
import com.filenet.api.core.Factory;
import com.filenet.api.core.ObjectStore;
import com.filenet.api.query.SearchSQL;
import com.filenet.api.query.SearchScope;
import com.filenet.api.util.UserContext;

/**
 * Connects, authenticates and returns the objectstore - for use in basic ad-hoc applications.
 * @author ivo jonker(.nl)
 * 
 */
public class Connection {

	private Connection(){}

	public static ObjectStore connectToObjectStore(String p8Url, String username, String password, String jaas, String objectstoreName){
		com.filenet.api.core.Connection connection = com.filenet.api.core.Factory.Connection.getConnection(p8Url);

		Subject subject =  UserContext.createSubject(connection, username, password, jaas);
		UserContext uc = UserContext.get();
		uc.pushSubject(subject);

		Domain domain = Factory.Domain.getInstance(connection, null);

		return Factory.ObjectStore.fetchInstance(domain, objectstoreName, null);
	}
	
	/**
	 * Executes a ce query returning a paged resultset (50).
	 * @param query
	 * @param os
	 * @return
	 */
	public static RepositoryRowSet executeQuery(String query, ObjectStore os){
		SearchSQL sqlObject = new SearchSQL();
		sqlObject.setQueryString(query);

		SearchScope searchScope = new SearchScope(os);
		return searchScope.fetchRows(sqlObject, 50, null, new Boolean(true));
	}
	
}
